/* get the size of the AVR RAM areas */
#include "ChipNames.h"                  // include our other file.

float TempVal =0;

void setup() {
  Serial.begin(9600);
  
  /* print chip name */
  Serial.print("Microprocessor type: "); //---- Put proper designation in here -----
  Serial.println(ChipName);

  /* speed code taken from http://playground.arduino.cc/Main/ShowInfo */
  Serial.print(F("Speed = "));
  Serial.print(F_CPU/1000000,DEC);
  Serial.println(F(" MHz"));
  
  /* get Flash RAM size */
  TempVal= FLASHEND;
  TempVal= ((TempVal+1)/1024);
  Serial.print("Size of FLASH(using FLASHEND): ");
  Serial.print(TempVal);
  Serial.println("K");
  
  /* get SRAM size */
  TempVal= (RAMEND -255);          // sram begin at 256
  TempVal= ((TempVal+1)/1024);
  Serial.print("Size of SRAM (using RAMEND): ");
  Serial.print(TempVal); 
  Serial.println("K");
  
  /* get EEPROM size */
  TempVal= (E2END);
  TempVal= ((TempVal+1)/1024);
  Serial.print("Size of EEPROM(using E2END): ");
  Serial.print(TempVal);
  Serial.println("K");
  
  /* get free (unallocated) SRAM */
  Serial.print("Free SRAM: ");
  Serial.print(freeRam());
  Serial.println(" Bytes");
}
void loop() {};


/* http://stackoverflow.com/questions/960389/how-can-i-visualise-the-memory-sram-usage-of-an-avr-program */
int freeRam () {
  extern int __heap_start, *__brkval; 
  int v; 
  return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval); 
}
