//   <user home>\Arduino\libraries\ChipTemp\ChipTemp.h  
// http://www.avdweb.nl/arduino/hardware-interfacing/temperature-measurement.html
//------------------------------------------------------

#ifndef ChipTemp_H
#define ChipTemp_H
//------------------------------------------------------------------
// #include <WProgram.h> 
// this is a small change to Mr. van Dalen’s code.
// “WProgram.h” was used by the earlier versions of the Arduino IDE
// “Arduino.h” is used by the current version (1.0.5)
//------------------------------------------------------------------
#include "Arduino.h"

// ATmega328 temperature sensor interface 
// Rev 1.0 Albert van Dalen
// Based on "InternalTemp"
// Requires 166 ... 204 bytes program memory
// Resolution 0.1 degree

// Calibration values, set in decimals
//static const float offset = 335.2; 	// change this!
static const float offset = 329.0; 	    // Sainsmart Nano Number one
static const float gain = 1.06154;		

static const int samples = 1000; 		// must be >= 1000, else the gain setting has no effect

// Compile time calculations
static const long offsetFactor = offset * samples;
static const int divideFactor = gain * samples/10; // deci = 1/10

class ChipTemp 
{
public:
  ChipTemp();
  int deciCelsius(); 
  int celsius(); 
  int deciFahrenheit();
  int fahrenheit(); 
  
private:   
  inline void initialize(); 
  inline int readAdc();
};

#endif
