/*	Program: EEPROM Dump 
        This program prints the entire contents of the EEPROM   
        in HEX and ASCII (when applicable) to the USB/RS232 terminal */
#include <EEPROM.h>
unsigned long addr;                              // used for address in EEPROM
byte i,j,c;                                      // i=1 to 16 bytes, j=HEX index, c= single character
char buffer[22];                                 // char array for ASCII string

void setup()
{ Serial.begin(9600);                            // initalize serial port
  buffer[0] = ' ';                               // put space at beginning of char array
  buffer[1] = ' ';                               // put second space at beginning of char array
  buffer[18] =0;                                 // string termination for buffer
  buffer[19] =0;                                 // belts and suspenders
  Serial.println (F("EEPROM DUMP:"));            // information, notice the F() wrapper
  do
  { /* Read 16 characters from the EEprom into our buffer */
    /* ------ Print the address padded with spaces ------ */
    if (addr<1000) {Serial.print(' ');}          // space padding, char(32) is a space
    if (addr<100) {Serial.print(' ');}           // space padding
    if (addr<10) {Serial.print(' ');}            // space padding
    Serial.print (addr, DEC);                    // starting address for line
    Serial.print ("  ");                         // seperator, could be replaced with a tab ("\t")
    for (i=0; i<16; ++i)                         // 16 bytes at a time
      {  c= EEPROM.read(addr + i);               // read one byte
         buffer[i+2]=char(c);                    // stuff the character in our buffer
         /*--- print HEX value ---*/
         if (c < 0x10) {Serial.print('0');}      // pad HEX value with 0, 0x10 = F0 = 16
         Serial.print (c, HEX);                  // using HEX tells print how to format the number
         ++j;                                    // increment index for serperator
         if (j == 4)                             // if we have printed 4 values
           {  Serial.print(' ');                 // print a seperator 
              j=0;                               // set our index back to zero to start over
           }
         /*--- Evaluate character ---*/
         if (c < 32) {buffer[i+2]='.';}          // do not print control codes
         if (c ==92) {buffer[i+2]='.';}          // do not print "\"
         if (c >126) {buffer[i+2]='.';}          // do not print 'extended' characters
      }
    Serial.println(buffer);                      // begin wiht a new line
    addr=addr +16;
  } while (addr < E2END);                        // E2END is the end of the EEPROM
}

void loop() { } // do nothing 

