
/*	Program: EEPROM Dump2 
        This program prints the entire contents of the EEPROM   
        in HEX and ASCII (when applicable) to the USB/RS232 terminal */
#include <EEPROM.h>
#include <HexDecAsc.h>

void setup()
{ Serial.begin(9600);                                      // initalize serial port
  EEPROMDump();                                            // call function
}

void loop() { } // do nothing 

void EEPROMDump()                                          // function to dump EEPROM
  { char buffer[60];                                       // allocate buffer 
    unsigned int addr=0;                                   // set start address
    Serial.println("EEPROM Dump:");                        // inform the user
    while (addr < E2END)                                   // run until we reach the end
      { for (byte i=0; i<16; i++)                          // process 16 bytes at a time
          { buffer[i]=EEPROM.read(addr++);                 // read EEPROM 
          }
        Serial.println(formatRamDump(addr-16, buffer));    // print formatted string      
      }  
  }

