/* Program: EEPROM_Erase 
   Writes a 1 to every bit location in the EEPROM */
        
#include <EEPROM.h>                     // include system EEPROM library
unsigned long addr=0;                   // adress to be read/written
unsigned long wcount=0;                 // number of bytes actually written
const unsigned addrEnd=E2END+1;         // compute end condition at compile time
const byte w = B11111111;               // values to write, binary notation for FF Hex

void setup()
{ Serial.begin(9600);                   // initalize serial port
  /* Warn the user what is going to happen and get a confirmation before proceeding */  
  Serial.println ("This will overwrite the entire EEPROM with ones."); 
  Serial.println ("Enter 'Y' to proceed.");
  while (Serial.available() == 0);      // wait for responce
  if (Serial.read()=='Y')               // if Y then proceed
    { do
      { if ((EEPROM.read(addr)) != w)   // check to see if byte needs to be written
        { EEPROM.write(addr, 0xFF);     // write one byte
          wcount++;                     // increment counter
          delay (10);                   // EEPROM is slow, allow it time
        }
        ++addr;                         // increment address
      } while (addr < addrEnd);         // the end of the EEPROM
      Serial.println (addr-1, DEC);     // print last address
      Serial.println (E2END, DEC);      // print EEPROM end address
      Serial.print ("Bytes written:");  // print actual bytes written
      Serial.println (wcount,DEC);
    }
  else                                  // Notify user operation was aborted 
    { Serial.println ("EEPROM erase aborted.");}
}
void loop() { } // do nothing 


