/*
 * EEPROM Read
 *
 * Reads values from the EEPROM.
 * These values will stay in the EEPROM when the board is
 * turned off and may be retrieved later by another sketch.
 */

#include <EEPROM.h>

// the current address in the EEPROM 
// (i.e. which byte we're going to read from next)
int addr = 0;
byte value;

void setup()
{
  // initialize serial and wait for port to open:
  Serial.begin(9600);
  delay (1000);
  for (addr=0; addr<26; addr= addr+1)
    { 
      value = EEPROM.read(addr);
      Serial.print(addr);
      Serial.print("\t");
      Serial.print(value, DEC);
      if (value == 0)
      {
       ; /* do nothing */ 
      }
      else
      {
        Serial.print("\t");
        Serial.print(char(value));
      }  
      Serial.println();
   }
}

void loop()
{
}
