/*	Program: Hello World 005 
        This program stores our Greeting strings in EEPROM.
        These values will remain when the board is turned off.   */
        
#include <EEPROM.h>
/* Addresses in EEPROM */
const word HelpStr =  00;   /* EEPROM location 0000 through 0051 */
const word English =  52;   /* EEPROM location 0052 through 0075 */
const word French  =  76;   /* EEPROM location 0076 through 0099 */
const word Spanish = 100;   /* EEPROM location 0100 through 0023 */
const word Italian = 124;   /* EEPROM location 0124 through 0147 */
const word TheEnd  = 148;   /* the end of our used EEPROM area   */

void setup()
{  Serial.begin(9600);
   storestring (HelpStr, English, "E=English, F=French, S=Spanish, I=Italian, A=All\0"); 
   storestring (English,  French, "Hello World\0");
   storestring (French,  Spanish, "Bonjour tout le monde\0");
   storestring (Spanish, Italian, "Hola mundo\0");
   storestring (Italian,  TheEnd, "Ciao mondo\0");
   // the "\0" is an "escape sequence" that tells the compiler we mean char(0)
   // which we could not normally type in a string. The compiler should terminate
   // the string for us ... I am just being extra careful (belts and suspenders).
}

void loop() { } // do nothing 

void storestring (word addrstart, word addrend, char greeting[])
  { byte chrcount = 0;                                 // this for the index into our char array
    byte singlechar=0x01;                              // holds a single character from the array
    word addr=addrstart;                               // this is the address that will be written
                                                       // continue until come to char(0)  
    while ((singlechar != 0) && (addr != addrend))     // or we reach the end of the allotated space
      { singlechar= greeting[chrcount++];              // get one character
        EEPROM.write(addr++, singlechar);              // write it to the EEPROM
        if (singlechar !=0) Serial.print (char(singlechar)); // this is for debugging 
        if (singlechar ==0) Serial.print ("\\0");      // "\\0" will print "\0"
        delay(10);                                     // allow time for EEPROM write to complete
      } 
     Serial.println("");                               // print a line feed
  }  
