/* develope function to format hex values as string */
#include <EEPROM.h>

void setup()
  {                              
    Serial.begin(9600);                             // eventually send the string out the serial port
    EEPROMDump();
  }

void loop(){;} // do nothing

void EEPROMDump()
  { word          addr = 0;
    byte hexbuffer[16];                                  // storage for the bytes to be converted      
    char OutStr[64];                                     // storage for the print string
    Serial.println ("EEPROM DUMP:");
    while (addr < E2END)                                 // loop until we reach the end of the EEPROM
      { AddrFormat('d',addr, OutStr);                    // format our address before it changes
        for (byte i=0; i<16; ++i)                        // proccess 16 bytes at a time
          { hexbuffer[i] = EEPROM.read (addr++);}        // read EEPROM into buffer 
        AscFormat(hexbuffer, OutStr);
        HexFormat(hexbuffer, OutStr);
        Serial.println (OutStr);
      }
    // AddrFormat('d',addr, OutStr);
    // Serial.println (OutStr);
  }

// -------- subroutines start here ---------------------------------------------------------------------
const char DIGITS[17] = "0123456789ABCDEF";              // ASCII representation of decimal/hexadecimal digits.

void AddrFormat(char f, word addr, char OutStr[])        // format the address in Decimal or Hex
  { byte i;                                              // used as index into string
    for (i=0; i<64; i++) {OutStr[i]=' ';}                // fill the string with spaces
    OutStr[63]=0;                                        // terminate the string with a 0
    i=0;                                                 // go back to the beginning
    if (f == 'h' || f == 'H')                            // if H or h was sent then use HEX for address
      { OutStr[i++] = DIGITS[((addr) >>12) & 0x0F];      // top nibble 
        OutStr[i++] = DIGITS[((addr) >>8) & 0x0F];       // next nibble
        OutStr[i++] = DIGITS[((addr) >>4) & 0x0F];       // next nibble   
        OutStr[i++] = DIGITS[(addr) & 0x0F];             // last nibble
        OutStr[i] = 'H';                                 // we have an extra byte, use it to indicate HEX
      }
    else                                                 // this is the default Decimal form 
      { OutStr[i++] = DIGITS[addr/10000];                // Use intger math to get each digit: 54321/10000=5
        OutStr[i++] = DIGITS[(addr % 10000)/1000];       // 54321 % 10000= 4321, 4321/1000=4
        OutStr[i++] = DIGITS[(addr % 1000)/100];         // 54321 % 1000 = 321, 321/100=3
        OutStr[i++] = DIGITS[(addr % 100)/10];           // 54321 % 100 = 21, 21/10=2 
        OutStr[i] = DIGITS[addr %10];                    // 54321 % 10 = 1
      }                                                  // % is the modulo (remainder) operator 
  }                                                 

// -------------------------------------------
void HexFormat(byte hexbuffer[], char OutStr[])          // Format the data bytes in Hex
  { char *OutHex = &OutStr[7];                           // pointer for HEX characters
    byte j=34, i, k, f=0;                                // working variables
    for (i=16; i>0  ; i--)                               // index for hexbuffer
      { k=i-1;                                           // because we can not test for i<0
        OutHex[j--] = DIGITS[(hexbuffer[k] & 0xF)];      // format the low nibble
        OutHex[j--] = DIGITS[((hexbuffer[k]) >>4)];      // format the high nibble
        f=f+2;                                           // when we printed 4 bytes
        if (f == 8) {j--; f=0;}                          // we want to skip a space
      }                                             
  }                                                 

// -------------------------------------------
void AscFormat(byte hexbuffer[], char OutStr[])          // Format the data bytes in ASCII
  { char *OutAsc = &OutStr[44];                          // pointer to ASCII characters
    byte n;                                              // working byte
    for (byte i=0; i<16; i++)                            // index for hexbuffer & OutAsc string
    { n=hexbuffer[i];                                    // get one byte                               
      OutAsc[i] = char(n);                               // format the character
     if (n <  32) {OutAsc[i]='.';}                       // check for control character
     if (n == 92) {OutAsc[i]='.';}                       // check for backslash
     if (n>126){OutAsc[i]='.';}                          // check for extended ASCII
    }                                                    // do it again sam
  }                                                 

  
  
